# HSI–MSER: Hyperspectral Image Registration Algorithm based on MSER and SIFT

## Requirements

* Ubuntu 18.04 or later

## Dependencies

* Install: `sudo apt-get install libmatio-dev`

## Usage

Run `./HSIMSER` with the following parameters:

`./HSIMSER <reference_image.mat> <target_image.mat> <number_of_bands_to_select>`

`<number_of_bands_to_select>` is the number of bands to select in the first stage of the algorithm. In the article, `8` is chosen as the default value. Other figures can be used.

Output:

* Textual result in console: scale, angle of rotation, and shifts over x and y axis.

## Additional program

`rot_scal` allows generating new target images with a specific scale and rotation angle to test the performance of the method.

Use:

`./rot_scal <image.mat> <scale> <angle>`

The output image is saved in the same directory with the name `rot_scal_out.mat`.

## Examples

Using Santa Barbara Line images:

`./HSIMSER SantaBarbaraLine2013.mat SantaBarbaraLine2014.mat 8`

Using Pavia University image:

1. `./rot_scal PaviaUniversity.mat 2.0 90`
2. `./HSIMSER PaviaUniversity.mat ./rot_scal_out.mat 8`

## Citation

This algorithm was presented in the article "HSI–MSER: Hyperspectral Image Registration Algorithm based on MSER and SIFT", which is under review in [IEEE Journal of Selected Topics in Applied Earth Observations and Remote Sensing](https://doi.org). If you use this program in your research projects, we encourage you to please cite our work:

```
@article{alvaro2021hsimser,
    title = {{HSI-MSER: Hyperspectral Image Registration Algorithm based on MSER and SIFT}},
    journal = {IEEE Journal of Selected Topics in Applied Earth Observations and Remote Sensing},
    author = {Ord{\'o}{\~n}ez, {\'A}lvaro and Acci{\'o}n, {\'A}lvaro and Arg{\"u}ello, Francisco and Heras, Dora B}
}
```